#ifndef MSP_GL_BUFFER_BACKEND_H_
#define MSP_GL_BUFFER_BACKEND_H_

#include <msp/core/noncopyable.h>

namespace Msp {
namespace GL {

class OpenGLBuffer: public NonCopyable
{
	friend class OpenGLPipelineState;
	friend class OpenGLTexture2D;
	friend class OpenGLVertexSetup;

protected:
	unsigned id = 0;

	OpenGLBuffer();
	OpenGLBuffer(OpenGLBuffer &&);
	~OpenGLBuffer();

	void allocate();
	void sub_data(size_t, size_t, const void *);

	bool can_map() const { return true; }
	void *map();
	bool unmap();

	void set_debug_name(const std::string &);

	void bind_scratch();
	static void unbind_scratch();
};

using BufferBackend = OpenGLBuffer;

} // namespace GL
} // namespace Msp

#endif
