#ifndef MSP_GL_FRAMEBUFFER_BACKEND_H_
#define MSP_GL_FRAMEBUFFER_BACKEND_H_

#include <string>
#include <msp/core/noncopyable.h>
#include "frameformat.h"

namespace Msp {
namespace GL {

class OpenGLFramebuffer: public NonCopyable
{
	friend class OpenGLCommands;
	friend class OpenGLPipelineState;

protected:
	unsigned id = 0;
	mutable unsigned status;

	OpenGLFramebuffer(bool);
	OpenGLFramebuffer(OpenGLFramebuffer &&);
	~OpenGLFramebuffer();

	void set_system_format(const FrameFormat &);
	static bool is_format_supported(const FrameFormat &);
	static void require_layered();

	void resize_system(unsigned, unsigned);
	void update(unsigned) const;
	void require_complete() const;

	void set_debug_name(const std::string &);
};

using FramebufferBackend = OpenGLFramebuffer;

} // namespace GL
} // namespace Msp

#endif
