#ifndef MSP_GL_PIPELINESTATE_BACKEND_H_
#define MSP_GL_PIPELINESTATE_BACKEND_H_

#include <vector>
#include <msp/core/noncopyable.h>

namespace Msp {
namespace GL {

class Device;

class OpenGLPipelineState: public NonCopyable
{
	friend class OpenGLCommands;

protected:
	mutable Device *applied_to = 0;
	mutable unsigned changes = 0;

	OpenGLPipelineState() = default;
	OpenGLPipelineState(OpenGLPipelineState &&) { }
	~OpenGLPipelineState();

	void apply() const;

	static void clear();
};

using PipelineStateBackend = OpenGLPipelineState;

} // namespace GL
} // namespace Msp

#endif
