#ifndef MSP_GL_QUERY_BACKEND_H_
#define MSP_GL_QUERY_BACKEND_H_

#include <msp/core/noncopyable.h>
#include <vector>

namespace Msp {
namespace GL {

class OpenGLQueryPool: public NonCopyable
{
	friend class OpenGLCommands;

protected:
	unsigned gl_type;
	std::vector<unsigned> queries;

	OpenGLQueryPool(unsigned);
	OpenGLQueryPool(OpenGLQueryPool &&);
	~OpenGLQueryPool();

	void resize();

	unsigned get_result(unsigned) const;
};

using QueryPoolBackend = OpenGLQueryPool;

unsigned get_gl_query_type(unsigned);

} // namespace GL
} // namespace Msp

#endif
