#ifndef MSP_GL_SAMPLER_BACKEND_H_
#define MSP_GL_SAMPLER_BACKEND_H_

#include <msp/core/noncopyable.h>

namespace Msp {
namespace GL {

class OpenGLSampler: public NonCopyable
{
	friend class OpenGLPipelineState;

protected:
	unsigned id = 0;

	OpenGLSampler();
	OpenGLSampler(OpenGLSampler &&);
	~OpenGLSampler();

	static bool check_anisotropic(bool);

	void update(unsigned) const;

	void set_debug_name(const std::string &);
};

using SamplerBackend = OpenGLSampler;

unsigned get_gl_filter(unsigned);
unsigned get_gl_wrap(unsigned);

} // namespace GL
} // namespace Msp

#endif
