#include "gl.h"
#include "stenciltest.h"
#include "stenciltest_backend.h"

using namespace std;

namespace Msp {
namespace GL {

unsigned get_gl_stencil_op(StencilOp op)
{
	switch(op)
	{
	case KEEP: return GL_KEEP;
	case SET_ZERO: return GL_ZERO;
	case REPLACE: return GL_REPLACE;
	case INCR_CLAMP: return GL_INCR;
	case DECR_CLAMP: return GL_DECR;
	case INVERT: return GL_INVERT;
	case INCR_WRAP: return GL_INCR_WRAP;
	case DECR_WRAP: return GL_DECR_WRAP;
	default: throw invalid_argument("get_gl_stencil_op");
	}
}

} // namespace GL
} // namespace Msp
