#ifndef MSP_GL_TEXTURE2D_BACKEND_H_
#define MSP_GL_TEXTURE2D_BACKEND_H_

#include "texture.h"

namespace Msp {
namespace GL {

class Buffer;

class OpenGLTexture2D: public Texture
{
protected:
	class AsyncLoader;

	OpenGLTexture2D();

	void allocate();
	void sub_image(unsigned, int, int, unsigned, unsigned, const void *);
	void sub_image(unsigned, int, int, unsigned, unsigned, const Buffer &, unsigned);

public:
	virtual Resource::AsyncLoader *load(IO::Seekable &, const Resources * = 0);
	virtual std::size_t get_data_size() const;
	virtual void unload();
};

using Texture2DBackend = OpenGLTexture2D;

} // namespace GL
} // namespace Msp

#endif
