#include <msp/gl/extensions/ext_texture_array.h>
#include "texture2darray_backend.h"

namespace Msp {
namespace GL {

OpenGLTexture2DArray::OpenGLTexture2DArray():
	Texture3D(GL_TEXTURE_2D_ARRAY)
{
	static Require _req(EXT_texture_array);
}

size_t OpenGLTexture2DArray::get_data_size() const
{
	if(!id)
		return 0;

	size_t level_size = width*height*get_pixel_size(format);
	size_t total_size = level_size;
	for(unsigned i=0; i<levels; ++i, level_size>>=2)
		total_size += level_size*depth;
	return total_size;
}

} // namespace GL
} // namespace Msp
