#ifndef MSP_GL_TEXTURE_BACKEND_H_
#define MSP_GL_TEXTURE_BACKEND_H_

#include <msp/core/noncopyable.h>

namespace Msp {
namespace GL {

class OpenGLTexture: public NonCopyable
{
	friend class OpenGLFramebuffer;
	friend class OpenGLPipelineState;

protected:
	unsigned id = 0;
	unsigned target;
	std::string debug_name;

	OpenGLTexture(unsigned);
	OpenGLTexture(OpenGLTexture &&);
	~OpenGLTexture();

	void create();
	void require_swizzle();
	void apply_swizzle();
	void set_parameter_i(unsigned, int) const;

	void generate_mipmap();

	void set_debug_name(const std::string &);

	void bind_scratch();
	static void unbind_scratch();
};

using TextureBackend = OpenGLTexture;

} // namespace GL
} // namespace Msp

#endif
