#ifndef MSP_GL_TEXTURECUBE_BACKEND_H_
#define MSP_GL_TEXTURECUBE_BACKEND_H_

#include "texture.h"

namespace Msp {
namespace GL {

class OpenGLTextureCube: public Texture
{
protected:
	OpenGLTextureCube();

	void allocate();
	void sub_image(unsigned, unsigned, int, int, unsigned, unsigned, const void *);

public:
	virtual AsyncLoader *load(IO::Seekable &, const Resources * = 0) { return 0; }
	virtual std::size_t get_data_size() const;
	virtual void unload() { }
};

using TextureCubeBackend = OpenGLTextureCube;

unsigned get_gl_cube_face(unsigned);

} // namespace GL
} // namespace Msp

#endif
