#ifndef MSP_GL_VERTEXSETUP_BACKEND_H_
#define MSP_GL_VERTEXSETUP_BACKEND_H_

#include <msp/core/noncopyable.h>

namespace Msp {
namespace GL {

class VertexArray;
class VertexFormat;

class OpenGLVertexSetup: public NonCopyable
{
	friend class OpenGLPipelineState;

protected:
	unsigned id;

	OpenGLVertexSetup();
	OpenGLVertexSetup(OpenGLVertexSetup &&);
	~OpenGLVertexSetup();

	static void require_format(const VertexFormat &, bool);
	void update(unsigned) const;
	void update_vertex_array(const VertexArray &, unsigned, unsigned, bool) const;

	void unload();

	void set_debug_name(const std::string &);
};

using VertexSetupBackend = OpenGLVertexSetup;

} // namespace GL
} // namespace Msp

#endif
