#ifndef MSP_GL_WINDOWVIEW_BACKEND_H_
#define MSP_GL_WINDOWVIEW_BACKEND_H_

#include "systemframebuffer.h"
#include "view.h"

namespace Msp {
namespace GL {

class OpenGLWindowView: public View
{
protected:
	OpenGLSystemFramebuffer sys_framebuf;

	OpenGLWindowView() = default;

	virtual void render();
	virtual const Framebuffer &get_target() const { return sys_framebuf; }

	void resize_framebuffer(unsigned, unsigned);
};

using WindowViewBackend = OpenGLWindowView;

} // namespace GL
} // namespace Msp

#endif
