#include <stdexcept>
#include "frameformat.h"
#include "frameformat_backend.h"
#include "vulkan.h"

using namespace std;

namespace Msp {
namespace GL {

unsigned get_vulkan_samples(unsigned samples)
{
	switch(samples)
	{
	case 1: return VK_SAMPLE_COUNT_1_BIT;
	case 2: return VK_SAMPLE_COUNT_2_BIT;
	case 4: return VK_SAMPLE_COUNT_4_BIT;
	case 8: return VK_SAMPLE_COUNT_8_BIT;
	case 16: return VK_SAMPLE_COUNT_16_BIT;
	case 32: return VK_SAMPLE_COUNT_32_BIT;
	case 64: return VK_SAMPLE_COUNT_64_BIT;
	default: throw invalid_argument("get_vulkan_samples");
	}
}

} // namespace GL
} // namespace Msp
