#ifndef MSP_GL_VULKAN_PIPELINECACHE_H_
#define MSP_GL_VULKAN_PIPELINECACHE_H_

#include <cstdint>
#include <map>
#include "frameformat.h"
#include "handles.h"

namespace Msp {
namespace GL {

class Device;
class PipelineState;

class PipelineCache
{
private:
	Device &device;
	VkDescriptorPool descriptor_pool;
	std::map<std::uint64_t, VkRenderPass> render_passes;
	std::map<std::uint64_t, VkPipeline> pipelines;
	std::map<std::uint64_t, VkDescriptorSet> descriptor_sets;

public:
	PipelineCache(Device &);
	PipelineCache(PipelineCache &&);
	~PipelineCache();

	VkRenderPass get_render_pass(const FrameFormat &, bool, bool, bool);
	VkPipeline get_pipeline(const PipelineState &);
	VkDescriptorSet get_descriptor_set(const PipelineState &, unsigned);
};

} // namespace GL
} // namespace Msp

#endif
