#ifndef MSP_GL_QUERY_BACKEND_H_
#define MSP_GL_QUERY_BACKEND_H_

#include <msp/core/noncopyable.h>
#include <vector>

namespace Msp {
namespace GL {

class VulkanQueryPool: public NonCopyable
{
	friend class VulkanCommands;

protected:
	unsigned vulkan_type;

	VulkanQueryPool(unsigned);
	VulkanQueryPool(VulkanQueryPool &&);
	~VulkanQueryPool();

	void resize();

	unsigned get_result(unsigned) const;
};

using QueryPoolBackend = VulkanQueryPool;

unsigned get_vulkan_query_type(unsigned);

} // namespace GL
} // namespace Msp

#endif
