#include "renderer.h"
#include "renderer_backend.h"

namespace Msp {
namespace GL {

void VulkanRenderer::begin(Semaphore &sem)
{
	static_cast<Renderer *>(this)->begin();

	begin_semaphore = &sem;
}

void VulkanRenderer::end()
{
	static_cast<Renderer *>(this)->commands.use_pipeline(0);
}

void VulkanRenderer::end(Semaphore &sem)
{
	Renderer &self = *static_cast<Renderer *>(this);
	self.end();
	self.commands.submit_frame(begin_semaphore, &sem);
}

} // namespace GL
} // namespace Msp
