#ifndef MSP_GL_RENDERER_BACKEND_H_
#define MSP_GL_RENDERER_BACKEND_H_

#include <msp/core/noncopyable.h>
#include "commands.h"
#include "pipelinestate.h"

namespace Msp {
namespace GL {

class VulkanRenderer: public NonCopyable
{
protected:
	PipelineState pipeline_state;
	Semaphore *begin_semaphore;

	void begin() { }
	void begin(Semaphore &);

	void end();
	void end(Semaphore &);
};

using RendererBackend = VulkanRenderer;

} // namespace GL
} // namespace Msp

#endif
