#ifndef MSP_GL_SAMPLER_BACKEND_H_
#define MSP_GL_SAMPLER_BACKEND_H_

#include "handles.h"

namespace Msp {
namespace GL {

class Device;

class VulkanSampler
{
	friend class VulkanPipelineState;

protected:
	Device &device;
	mutable VkSampler handle = 0;
	std::string debug_name;

	VulkanSampler();
	VulkanSampler(VulkanSampler &&);
	~VulkanSampler();

	static bool check_anisotropic(bool) { return true; }

	void update(unsigned) const;

	void set_debug_name(const std::string &);
	void set_vulkan_object_name() const;
};

using SamplerBackend = VulkanSampler;

unsigned get_vulkan_filter(unsigned);
unsigned get_vulkan_mipmap_mode(unsigned);
unsigned get_vulkan_address_mode(unsigned);

} // namespace GL
} // namespace Msp

#endif
