#include "device.h"
#include "semaphore.h"
#include "vulkan.h"

namespace Msp {
namespace GL {

Semaphore::Semaphore():
	device(Device::get_current())
{
	const VulkanFunctions &vk = device.get_functions();

	VkSemaphoreCreateInfo semaphore_info = { };
	semaphore_info.sType = VK_STRUCTURE_TYPE_SEMAPHORE_CREATE_INFO;

	vk.CreateSemaphore(semaphore_info, handle);
}

Semaphore::~Semaphore()
{
	device.get_destroy_queue().destroy(handle);
}

} // namespace GL
} // namespace Msp
