#include "error.h"
#include "structurebuilder.h"

using namespace std;

namespace Msp {
namespace GL {

StructureBuilder::StructureBuilder(vector<char> &s, unsigned max_parts):
	storage(s)
{
	storage.clear();
	parts.reserve(max_parts);
}

void *&StructureBuilder::add(std::size_t size, std::size_t align)
{
	if(parts.size()>=parts.capacity())
		throw invalid_operation("StructureBuilder::add");

	parts.emplace_back();
	Part &part = parts.back();
	part.offset = storage.size()+align-1;
	part.offset -= part.offset%align;

	storage.resize(part.offset+size);
	for(Part &p: parts)
		p.pointer = storage.data()+p.offset;

	return parts.back().pointer;
}

} // namespace GL
} // namespace Msp
