#ifndef MSP_GL_TEXTURE1D_BACKEND_H_
#define MSP_GL_TEXTURE1D_BACKEND_H_

#include "texture.h"

namespace Msp {
namespace GL {

class VulkanTexture1D: public Texture
{
protected:
	VulkanTexture1D();

	virtual void fill_image_info(void *) const;
	void sub_image(unsigned, int, unsigned, const void *);

public:
	virtual AsyncLoader *load(IO::Seekable &, const Resources * = 0) { return 0; }
	virtual std::size_t get_data_size() const;
	virtual void unload() { }
};

using Texture1DBackend = VulkanTexture1D;

} // namespace GL
} // namespace Msp

#endif
