#ifndef MSP_GL_TEXTURE2D_BACKEND_H_
#define MSP_GL_TEXTURE2D_BACKEND_H_

#include "texture.h"

namespace Msp {
namespace GL {

class VulkanTexture2D: public Texture
{
protected:
	VulkanTexture2D();

	virtual void fill_image_info(void *) const;
	void sub_image(unsigned, int, int, unsigned, unsigned, const void *);

public:
	virtual Resource::AsyncLoader *load(IO::Seekable &, const Resources * = 0);
	virtual std::size_t get_data_size() const;
	virtual void unload();
};

using Texture2DBackend = VulkanTexture2D;

} // namespace GL
} // namespace Msp

#endif
