#include "texture2darray_backend.h"
#include "vulkan.h"

namespace Msp {
namespace GL {

VulkanTexture2DArray::VulkanTexture2DArray():
	Texture3D(VK_IMAGE_VIEW_TYPE_2D_ARRAY)
{ }

void VulkanTexture2DArray::fill_image_info(void *ii) const
{
	VkImageCreateInfo *image_info = static_cast<VkImageCreateInfo *>(ii);
	image_info->imageType = VK_IMAGE_TYPE_2D;
	image_info->extent.width = width;
	image_info->extent.height = height;
	image_info->mipLevels = levels;
	image_info->arrayLayers = depth;
}

} // namespace GL
} // namespace Msp
