#include "frameformat.h"
#include "texture2dmultisample.h"
#include "texture2dmultisample_backend.h"
#include "vulkan.h"

namespace Msp {
namespace GL {

VulkanTexture2DMultisample::VulkanTexture2DMultisample():
	Texture(VK_IMAGE_TYPE_2D)
{
	throw std::logic_error("VulkanTexture2DMultisample is unimplemented");
}

void VulkanTexture2DMultisample::fill_image_info(void *ii) const
{
	const Texture2DMultisample &self = *static_cast<const Texture2DMultisample *>(this);

	VkImageCreateInfo *image_info = static_cast<VkImageCreateInfo *>(ii);
	image_info->imageType = VK_IMAGE_TYPE_2D;
	image_info->extent.width = self.width;
	image_info->extent.height = self.height;
	image_info->samples = static_cast<VkSampleCountFlagBits>(get_vulkan_samples(self.samples));
}

size_t VulkanTexture2DMultisample::get_data_size() const
{
	return 0;
}

} // namespace GL
} // namespace Msp
