#ifndef MSP_GL_TEXTURE2DMULTISAMPLE_BACKEND_H_
#define MSP_GL_TEXTURE2DMULTISAMPLE_BACKEND_H_

#include "texture.h"

namespace Msp {
namespace GL {

class VulkanTexture2DMultisample: public Texture
{
protected:
	VulkanTexture2DMultisample();

	virtual void fill_image_info(void *) const;

public:
	virtual AsyncLoader *load(IO::Seekable &, const Resources * = 0) { return 0; }
	virtual std::size_t get_data_size() const;
	virtual void unload() { }
};

using Texture2DMultisampleBackend = VulkanTexture2DMultisample;

} // namespace GL
} // namespace Msp

#endif
