#ifndef MSP_GL_TEXTURE3D_BACKEND_H_
#define MSP_GL_TEXTURE3D_BACKEND_H_

#include "texture.h"

namespace Msp {
namespace GL {

class VulkanTexture3D: public Texture
{
protected:
	VulkanTexture3D();
	VulkanTexture3D(unsigned);

	virtual void fill_image_info(void *) const;
	void sub_image(unsigned, int, int, int, unsigned, unsigned, unsigned, const void *);

	bool is_array() const;

public:
	virtual AsyncLoader *load(IO::Seekable &, const Resources * = 0) { return 0; }
	virtual std::size_t get_data_size() const;
	virtual void unload() { }
};

using Texture3DBackend = VulkanTexture3D;

} // namespace GL
} // namespace Msp

#endif
