#ifndef MSP_GL_TEXTURECUBE_BACKEND_H_
#define MSP_GL_TEXTURECUBE_BACKEND_H_

#include "texture.h"

namespace Msp {
namespace GL {

class VulkanTextureCube: public Texture
{
protected:
	VulkanTextureCube();

	virtual void fill_image_info(void *) const;
	void sub_image(unsigned, unsigned, int, int, unsigned, unsigned, const void *);

public:
	virtual AsyncLoader *load(IO::Seekable &, const Resources * = 0) { return 0; }
	virtual std::size_t get_data_size() const;
	virtual void unload() { }
};

using TextureCubeBackend = VulkanTextureCube;

} // namespace GL
} // namespace Msp

#endif
